/*
 * Matrix effect
 * (c) 2006, Francois Revol <revol@free.fr>
 * lots of heuristics in there...
 */

#include <lib.h>
#include "invit.h"

#define CYCLES 64

#define SCOL 2

#define NLIN 28

char start[NCOL];
char stop[NCOL];

/* XXX: TODO: split out the loop ? */
/* XXX: FIXME: shouldn't require (unsigned char) casts in charat... */

void do_matrix(char duration)
{
  char counter;
  char col;
  char i;

  // +VIA_TA_LO ?
  //srandom(get()+getdeadkeys()+GETPAPER+GETINK+getflags());
  text();
  memset(TEXTVRAM,' ',NCOL*1/*NLIN*/);
  paper(A_FWBLACK);
  ink(A_FWGREEN);
  poke(TEXTVRAM,A_BGBLACK);
  poke(TEXTVRAM+1,A_FWGREEN); // ink() doesn't set status line...
  
  // install matrixcode font
  memcpy((char *)STDCHRTABLE+32*8,MCodeFont,(int)(MCodeFontEnd-MCodeFont));
  
  // loop several times
  for (; duration; duration--) {
    for (counter = CYCLES; counter; counter--) {
      // fancy effect
      //for (col = SCOL; col < NCOL; col++) {
      for (col = SCOL + (myrand()&7); col < NCOL; col += (myrand()&5) + 1) {
	char r = myrand();
	char sta = start[col];
	char sto = stop[col];
	// sometimes 
	if (r & 0x70) {
	  // scroll down
	  if (sto >= (NLIN-1)) {
	    sta++;
	    if ((sta >= (NLIN-1)) || (r & 0x8)) {
	      sta = 0;
	      sto = 1;
	    }
	  } else {
	    sto++;
	    if ((sto > 15) && (r & 0x10)) {
	      putat(col, sta, myrandc());
	      sta++;
	    }
	  }
	  //printf("scroll: %d to %d\n", sta[col], sto[col]);
	  // really scroll now
	  for (i = sto; i > sta; i--) {
	    char c = ' ';
	    if (i > 0)
	      c = charat(col, i-1);
	    if (c == ' ')
	      c = myrandc();
	    putat(col, i, c);
	  }
	  if (i > 0)
	    putat(col,i-1,' ');
	} else {
	  char cnt = r & 0x7 + 1;
	  while (cnt --)
	    // scramble all chars
	    for (i = sto; i > sta; i--) {
	      putat(col, i, myrandc());
	    }
	}
	start[col] = sta;
	stop[col] = sto;
      }
    }
  }
  
  /* redefine '_' to '_' (it's GB Pound on ORIC) */
  for (i = 0; i < 6; i++)
    *((char *)STDCHRTABLE+8*'_'+i) = 0;
  
  /* final message */
  dbl_text_out(10, 4, A_FWYELLOW, "YOU ARE THE ONE.");
  dbl_text_out(10+18, 4, A_FWGREEN, "");
  delay(3);
  dbl_text_out(3, 8, A_FWYELLOW, "Credits:");
  dbl_text_out(3+10, 8, A_FWGREEN, "");
  dbl_text_out(4, 10, A_FWYELLOW, "Coding: mmu_man");
  dbl_text_out(4+17, 10, A_FWGREEN, "");
  delay(5);
  /* this one used to be in an ST demo :) */
  dbl_text_out(5, 14, A_FWYELLOW, "REALITY.SYS CORRUPTED.");
  dbl_text_out(5+24, 14, A_FWGREEN, "");
  delay(5);
  dblblk_text_out(5, 16, A_FWRED, "REBOOTING UNIVERSE...");
  dbl_text_out(5+23, 16, A_FWGREEN, "");
  delay(10);
}

